//------------------------------------------------------------------------------
//
// PROJECT : Fruechtetee
//
// FILE    : main.cpp
//
// VERSION : 1.0
//
//------------------------------------------------------------------------------
//
//
//---------------------------------------------------------------------------

#include <iostream>
#include <fstream>
#include <vector>
#include <list>

using namespace std;

#include <CComplex.h>
#include <CComplex.hpp>
#include "CThread.h"
#include "CSuperThread.hpp"
#include "CFractThread.h"

struct SAsmParams
{
  int    mLineSize;  // 0
	int    mIter;      // 4
  double mStep;      // 8
	int*   mFractData; // 16
};

extern "C"
{
	void asmInitComplex(void);
	int asmMandelBrot(CComplex<double>* c0, int Iter);
	int asmMandelBrotLine(CComplex<double>* c0, SAsmParams* ap);
};

//#define USE_X86_ASSEMBLER

void CFractThread::ThreadServiceRoutine()
{
	/*
	cout << "ThreadServiceRoutine START" << endl;
	cout << mC.real << " i" << mC.imag << endl;
	cout << "StepX=" << mStepX << " Iter=" << mIter << endl;
	*/
	#ifdef USE_X86_ASSEMBLER

	asmInitComplex();

	SAsmParams asmParams;

	asmParams.mFractData = mFractData;
  asmParams.mLineSize  = mWidth;
  asmParams.mStep      = mStepX;
	asmParams.mIter      = mIter;

	asmMandelBrotLine(&mC, &asmParams);

/*
	for (int x = 0; x < mWidth; x++)
	{
		mFractData[x]	=	asmMandelBrot(&mC, mIter);
		mC.real += mStepX;
	}	
*/
	#else

	for (int x = 0; x < mWidth; x++)
	{
		mFractData[x] = mC.MandelBrot(mIter);
		mC.real += mStepX;
	}

	#endif
	//Sleep(1000);
	//cout << "ThreadServiceRoutine END" << endl;
}


