
#ifndef CLOGTABLE_HPP
#define CLOGTABLE_HPP


template <typename T>
T CLogTable<T>::GetLogTable(T v)
{
	double dyn    = mIntervBis - mIntervVon;
	double dynMap = mMapBis - mMapVon;

	//
	// normalv ist im Bereich zwische 0 und 1
	//

  double normalv = (v - mIntervVon) / dyn;

	//
	// transv potenziert in den Bereich MapVon
	// bis MapBis gemappt
	//

  T transv  = (pow(normalv, mPotenz) * dynMap)  + mMapVon;

  return transv;
}

template <typename T>
void CLogTable<T>::Init(T iv, T ib, T mapv, T mapb, double p, bool CreateMap)
{
	mIntervVon = iv;
	mIntervBis = ib;
	mMapVon    = mapv;
	mMapBis    = mapb;
	mPotenz    = p;

	mMapSize = mIntervBis - mIntervVon;

	if (CreateMap)
	{
		mMap = new T[mMapSize];
		for (int i = mIntervVon; i < mIntervBis; i++)
		{
			mMap[i - mIntervVon] = GetLogTable(i);
		}
	}
}

template <typename T>
T CLogTable<T>::GetLogMap(T v)
{
	T r;
	if (mMap != NULL)
	{
		r = mMap[v - mIntervVon];
	}
	else
	{
		r = 0;
	}
	return r;
}

#endif
