//------------------------------------------------------------------------------
//
// PROJECT : Fruechtebrot Fractal Batch
//
// FILE    : main.cpp
//
// VERSION : 1.0
//
//---------------------------------------------------------------------------

#include <iostream>
#include <fstream>
#include <vector>
#include <list>

using namespace std;

#include "CPicWriter.h"

// ---------------------------------------------------------------------------
//
// KLASSE        : CPicWriter
// METHODE       : InitPicWriter
//
//
//
// ---------------------------------------------------------------------------


void CPicWriter::InitPicWriter(CGraflibTga* tga)
{
	mAntiAlias = 4;
  mTga = tga;
}

// ---------------------------------------------------------------------------
//
// KLASSE        : CPicWriter
// METHODE       : Finish
//
//
//
// ---------------------------------------------------------------------------

void CPicWriter::Finish()
{
	mTga->CloseWriteLine();
}


// ---------------------------------------------------------------------------
//
// KLASSE        : CPicWriter
// METHODE       : AddBitmap
//
//
//
// ---------------------------------------------------------------------------

void CPicWriter::AddBitmap(CPixel24* BitmapData)
{
	mDataLines.push_back(BitmapData);
}

// ---------------------------------------------------------------------------
//
// KLASSE        : CPicWriter
// METHODE       : Sync
//
//
//
// ---------------------------------------------------------------------------

void CPicWriter::Sync()
{
	if (mDataLines.size() >= mAntiAlias)
	{	
		CPixel24*  ErgBuffer = new CPixel24[mTga->mWidth];
		CPixel24** LineData  = new CPixel24*[mAntiAlias];

		int j = 0;
		for (list<CPixel24*>::iterator id = mDataLines.begin(); 
                                   id != mDataLines.end() && (j < mAntiAlias);
                                 ++id, ++j)
		{
     	LineData[j] = *id;
		}

		for (int i = 0; i < 4; i++)
		{
			mDataLines.pop_front();
		}

		mTga->DownScaleLine4((unsigned char**) LineData, ErgBuffer, mTga->mWidth * 4);
    mTga->WriteLine(ErgBuffer);

		for (int i = 0; i < mAntiAlias; i++)
		{
			delete[] LineData[i];
		}
		delete[] ErgBuffer;
		delete[] LineData;
	}
}
