#ifndef CSUPERTHREAD_HPP
#define CSUPERTHREAD_HPP

//---------------------------------------------------------------------------
//
// Klasse:    CSuperThread
// Methode:		CreateThreads
//
//
//---------------------------------------------------------------------------

template <typename TThread>
void CSuperThread::InitThreads(TThread* threads, void** vars, int tcount)
{
	if (!mInit)
	{
		InitMutex();
		mThreadCount = tcount;

		for (int i = 0; i < tcount; i++)
		{
			if (vars == NULL)
			{
				threads[i].Create(this, NULL);
			}
			else
			{
				threads[i].Create(this, vars[i]);
			}
		}
		mInit = true;
	}
}

//---------------------------------------------------------------------------
//
// Klasse:    CSuperThread
// Methode:		StartThreads
//
//
//---------------------------------------------------------------------------

template <typename TThread>
void CSuperThread::StartThreads(TThread* threads, int tcount)
{
	mThreadCount = tcount;
	LockSuperMutex();
	for (int i = 0; i < tcount; i++)
	{
		threads[i].Start();
	}
}

#endif
