
template <class T>
class CComplex
{
	public:

		T real; // Realteil komplexen der Zahl
		T imag; // Imaginrteil der komplexen Zahl

    // ***************************************
    // Konstruktoren

    CComplex()
    {
			real = 0;
			imag = 0;
		}

    CComplex(T r, T i)
    {
			real = r;
			imag = i;
		}

    // ***************************************
    // Operatoren Complex & T

    // Setzen des Real- und Imaginrteils der
    // komplexen Zahl

		void set(T r, T i)
		{
			real = r;
			imag = i;
		}

    // Addition
		CComplex operator+(T c)
		{
			CComplex v;
			v.real = real + c;
			return v;
		}

    // Addition +=
		CComplex operator+=(T c)
		{
			real += c;
			return *this;
		}

		// Subtraktion -
		CComplex operator-(T c)
		{
			CComplex v;
			v.real = real - c;
			return v;
		}

		// Subtraktion -=
		CComplex operator-=(T c)
		{
			real -= c;
			return *this;
		}

		// Multiplikation *
		CComplex operator*(T c)
		{
			CComplex v;
			v.real = real * c;
			v.imag = imag * c;
			return v;
		}

		// Multiplikation *=
		CComplex operator*=(T c)
		{
			CComplex v;
			v = *this * c;
			return v;
		}

    // Division /
		CComplex operator/(T c)
		{
			CComplex v;
			v.real = real / c;
			v.imag = imag / c;
			return v;
		}

    // Division /=
		CComplex operator/=(T c)
		{
			CComplex v;
			v = *this / c;
			return v;
		}

    // ***************************************
    // Operatoren Complex & Complex


    // Zuweisung =
    CComplex operator=(CComplex c)
    {
			real = c.real;
			imag = c.imag;
			return *this;
		}

    // Addition +
		CComplex operator+(CComplex c)
		{
			CComplex v;
			v.real = real + c.real;
			v.imag = imag + c.imag;
			return v;
		}

    // Addition +=
		CComplex operator+=(CComplex c)
		{
			real += c.real;
			imag += c.imag;
			return *this;
		}

    // Subtraktion -
		CComplex operator-(CComplex c)
		{
			CComplex v;
			v.real = real - c.real;
			v.imag = imag - c.imag;
			return v;
		}

    // Subtraktion -=
		CComplex operator-=(CComplex c)
		{
			real -= c.real;
			imag -= c.imag;
			return *this;
		}

    // Multiplikation *
		CComplex operator*(CComplex c)
		{
			CComplex v;
			v.real = (real * c.real) - (imag * c.imag);
			v.imag = (real * c.imag) + (imag * c.real);
			return v;
		}

    // Multiplikation *=
		CComplex operator*=(CComplex c)
		{
			CComplex v;
			v = *this * c;
			return v;
		}

    // Konjunktion
		CComplex operator~()
		{
			CComplex v;
			v.real = real;
			v.imag = -imag;
			return v;
		}

    // Division /
		CComplex operator/(CComplex c)
		{
			CComplex v;
			v = (*this * ~c) / c.Betrag2();
			return v;
		}

    // Division /=
		CComplex operator/=(CComplex c)
		{
			*this = *this / c;
			return *this;
		}

    // ***************************************
    // Sonstige Funktionen

    // Betrag der komplexen Zahl zum Quadrat
    T Betrag2()
    {
			return (real * real) + (imag * imag);
		}

    // Quadrat einer komplexen Zahl
		CComplex sqr()
		{
			CComplex v;
			v.real = (real * real) - (imag * imag);
			v.imag =  real * imag * 2;
			return v;
		}

    // Mandelbrot-Funktion
    // iter - Anzahl der Interationen
    // Rckgabe:
    // -1 - Zahl gehrt zur Mandelbrotmenge
    // >0 - Anzahl der Iterationen nach Abbruch
		int MandelBrot(int iter);

};
