//------------------------------------------------------------------------------
//
// PROJECT : Fruechtebrot Fractal Batch
//
// FILE    : main.cpp
//
// VERSION : 1.0
//
//------------------------------------------------------------------------------
//
//
//---------------------------------------------------------------------------

#include <iostream>
#include <fstream>
#include <vector>
#include <list>

using namespace std;


#include <string.h>
#include <CRectT.h>
#include <CPixel24.h>
#include <CGraflibTga.h>
#include <CStringTool.hpp>
#include <CComplex.h>
#include <CComplex.hpp>
#include <CDatabase3.h>
#include <math.h>

#include "SColorProfile.h"
#include "CThread.h"
#include "CSuperThread.hpp"
#include "CFractThread.h"
#include "CLogTable.h"
#include "SFractParams.h"
#include "CFraktBitmap.h"
#include "CFractBatch.h"

 


//---------------------------------------------------------------------------
//
// KLASSE        : CFractBatch
// METHODE       :
//
//
//
// ---------------------------------------------------------------------------

int main(int argc, char* argv[])
{
  if (argc >= 6)
	{
		CStringTool StringTool;
		CFractBatch FractBatch;

		int Width  = StringTool.StringTo<int>(argv[1]);
		int Height = StringTool.StringTo<int>(argv[2]);
		int Iter   = StringTool.StringTo<int>(argv[3]);
		int Threads= StringTool.StringTo<int>(argv[4]);
		
		for (int i = 6; i < argc; i++)
		{
		  if (string(argv[i]) == "-raw")
		  {
		  	cout << "RAW is ON" << endl;
		  	FractBatch.mSaveRaw = true;
		  }
		} 

		if ((Threads > 0) && (Threads <= 256))
		{
			FractBatch.ParseBatchFile(argv[5], Width, Height, Iter, Threads);
		}
		else
		{
			cout << "ERROR: number of threads must be between 1 and 256" << endl;
		}
	}
	else
	{
		cout << "usage: fractbatch <width> <height> <iter> <threads> <batchfile.txt>" << endl;
		cout << "       Version 1.5 with 4xAA" << endl; 
    cout << "       Written by Martin Steen (martin@martin-steen.de)" << endl;
	}
	return 0;
}

